diff -urN ../VisualBoyAdvance-1.7.2/src/Cheats.h ./src/Cheats.h
--- ../VisualBoyAdvance-1.7.2/src/Cheats.h	2004-05-13 23:06:42 +0900
+++ ./src/Cheats.h	2006-04-30 23:35:35 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -25,6 +25,7 @@
   int size;
   int status;
   bool enabled;
+  u32 rawaddress;
   u32 address;
   u32 value;
   u32 oldValue;
@@ -32,7 +33,7 @@
   char desc[32];
 };
 
-extern void cheatsAdd(const char *,const char *,u32,u32,int,int);
+extern void cheatsAdd(const char *,const char *,u32, u32,u32,int,int);
 extern void cheatsAddCheatCode(const char *code, const char *desc);
 extern void cheatsAddGSACode(const char *code, const char *desc, bool v3);
 extern void cheatsAddCBACode(const char *code, const char *desc);
@@ -42,12 +43,12 @@
 extern void cheatsEnable(int number);
 extern void cheatsDisable(int number);
 extern void cheatsSaveGame(gzFile file);
-extern void cheatsReadGame(gzFile file);
+extern void cheatsReadGame(gzFile file, int version);
 extern void cheatsSaveCheatList(const char *file);
 extern bool cheatsLoadCheatList(const char *file);
-extern void cheatsWriteMemory(u32 *, u32, u32);
-extern void cheatsWriteHalfWord(u16 *, u16, u16);
-extern void cheatsWriteByte(u8 *, u8);
+extern void cheatsWriteMemory(u32, u32);
+extern void cheatsWriteHalfWord(u32, u16);
+extern void cheatsWriteByte(u32, u8);
 extern int cheatsCheckKeys(u32,u32);
 extern int cheatsNumber;
 extern CheatsData cheatsList[100];
diff -urN ../VisualBoyAdvance-1.7.2/src/EEprom.cpp ./src/EEprom.cpp
--- ../VisualBoyAdvance-1.7.2/src/EEprom.cpp	2004-05-13 23:38:22 +0900
+++ ./src/EEprom.cpp	2005-06-25 15:15:34 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -16,6 +16,7 @@
 // along with this program; if not, write to the Free Software Foundation,
 // Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
+#include <memory.h>
 #include "GBA.h"
 #include "EEprom.h"
 #include "Util.h"
@@ -42,6 +43,11 @@
   { NULL, 0 }
 };
 
+void eepromInit()
+{
+  memset(eepromData, 255, sizeof(eepromData));
+}
+
 void eepromReset()
 {
   eepromMode = EEPROM_IDLE;
diff -urN ../VisualBoyAdvance-1.7.2/src/EEprom.h ./src/EEprom.h
--- ../VisualBoyAdvance-1.7.2/src/EEprom.h	2004-05-13 23:06:31 +0900
+++ ./src/EEprom.h	2006-06-07 06:04:20 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -20,10 +20,11 @@
 #ifndef VBA_EEPROM_H
 #define VBA_EEPROM_H
 
-extern void eepromSaveGame(gzFile gzFile);
-extern void eepromReadGame(gzFile gzFile, int version);
+extern void eepromSaveGame(gzFile _gzFile);
+extern void eepromReadGame(gzFile _gzFile, int version);
 extern int eepromRead(u32 address);
 extern void eepromWrite(u32 address, u8 value);
+extern void eepromInit();
 extern void eepromReset();
 extern u8 eepromData[0x2000];
 extern bool eepromInUse;
diff -urN ../VisualBoyAdvance-1.7.2/src/Flash.cpp ./src/Flash.cpp
--- ../VisualBoyAdvance-1.7.2/src/Flash.cpp	2004-05-13 23:38:11 +0900
+++ ./src/Flash.cpp	2006-04-30 23:36:24 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -67,6 +67,11 @@
   { NULL, 0 }
 };
 
+void flashInit()
+{
+  memset(flashSaveMemory, 0xff, sizeof(flashSaveMemory));
+}
+
 void flashReset()
 {
   flashState = FLASH_READ_ARRAY;
@@ -95,7 +100,6 @@
 void flashSetSize(int size)
 {
   //  log("Setting flash size to %d\n", size);
-  flashSize = size;
   if(size == 0x10000) {
     flashDeviceID = 0x1b;
     flashManufacturerID = 0x32;
@@ -103,6 +107,11 @@
     flashDeviceID = 0x13; //0x09;
     flashManufacturerID = 0x62; //0xc2;
   }
+  // Added to make 64k saves compatible with 128k ones
+  // (allow wrongfuly set 64k saves to work for Pokemon games)
+  if ((size == 0x20000) && (flashSize == 0x10000))
+    memcpy((u8 *)(flashSaveMemory+0x10000), (u8 *)(flashSaveMemory), 0x10000);
+  flashSize = size;
 }
 
 u8 flashRead(u32 address)
@@ -146,6 +155,13 @@
   (*cpuSaveGameFunc)(address, byte);
 }
 
+void flashDelayedWrite(u32 address, u8 byte)
+{
+  saveType = 2;
+  cpuSaveGameFunc = flashWrite;
+  flashWrite(address, byte);
+}
+
 void flashWrite(u32 address, u8 byte)
 {
   //  log("Writing %02x at %08x\n", byte, address);
diff -urN ../VisualBoyAdvance-1.7.2/src/Flash.h ./src/Flash.h
--- ../VisualBoyAdvance-1.7.2/src/Flash.h	2004-05-13 23:05:20 +0900
+++ ./src/Flash.h	2006-06-07 06:04:20 +0900
@@ -20,14 +20,16 @@
 #ifndef VBA_FLASH_H
 #define VBA_FLASH_H
 
-extern void flashSaveGame(gzFile gzFile);
-extern void flashReadGame(gzFile gzFile, int version);
+extern void flashSaveGame(gzFile _gzFile);
+extern void flashReadGame(gzFile _gzFile, int version);
 extern u8 flashRead(u32 address);
 extern void flashWrite(u32 address, u8 byte);
+extern void flashDelayedWrite(u32 address, u8 byte);
 extern u8 flashSaveMemory[0x20000];
 extern void flashSaveDecide(u32 address, u8 byte);
 extern void flashReset();
 extern void flashSetSize(int size);
+extern void flashInit();
 
 extern int flashSize;
 #endif // VBA_FLASH_H
